Debian Bug report logs - #531522
libopenmpi-dev: mpicc segfaults under fakeroot

version graph

Package: libopenmpi-dev; Maintainer for libopenmpi-dev is Debian Open MPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>; Source for libopenmpi-dev is src:openmpi.

Reported by: Kurt Roeckx <kurt@roeckx.be>

Date: Mon, 1 Jun 2009 11:12:00 UTC

Severity: serious

Tags: confirmed

Found in version openmpi/1.3.2-2.1

Fixed in version openmpi/1.3.2-3

Done: Manuel Prinz <manuel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debichem Team <debichem-devel@lists.alioth.debian.org>:
Bug#531419; Package gromacs. (Mon, 01 Jun 2009 11:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
New Bug report received and forwarded. Copy sent to Debichem Team <debichem-devel@lists.alioth.debian.org>. (Mon, 01 Jun 2009 11:12:03 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: submit@bugs.debian.org
Subject: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Mon, 1 Jun 2009 12:57:49 +0200
Source: gromacs
Version: 4.0.5-2
Severity: serious

Hi,

There was an error while trying to autobuild your package:

> Start Time: 20090601-0920

[...]

> Build-Depends: debhelper (>= 5.0.0), dpatch, libfftw3-dev, libmpich1.0-dev (>= 1.2.7-6), lam4-dev, libopenmpi-dev (>= 1.2.4-5) [alpha amd64 i386 ia64 powerpc kfreebsd-i386 kfreebsd-amd64 hurd-i386], lesstif2-dev, libxt-dev, libsm-dev, libice-dev, libxext-dev, libxp-dev, libx11-dev, zlib1g-dev, libgsl0-dev, gfortran [alpha], autotools-dev (>= 20070725.1), autoconf, automake (>= 1:1.10), libtool

[...]

> Toolchain package versions: libc6-dev_2.9-13 linux-libc-dev_2.6.29-5 g++-4.3_4.3.3-10 gcc-4.3_4.3.3-10 binutils_2.19.1-1 libstdc++6_4.4.0-5 libstdc++6-4.3-dev_4.3.3-10
> 

[...]

> dh_shlibdeps -pgromacs-mpich -L gromacs-mpich -l debian/gromacs-mpich/usr/lib
> dpkg-shlibdeps: warning: dependency on libnsl.so.1 could be avoided if "debian/gromacs-mpich/usr/lib/libmd_mpi_d_mpich.so.5.0.0 debian/gromacs-mpich/usr/lib/libgmx_mpi_d_mpich.so.5.0.0 debian/gromacs-mpich/usr/lib/libmd_mpi_mpich.so.5.0.0 debian/gromacs-mpich/usr/bin/mdrun_mpi.mpich debian/gromacs-mpich/usr/bin/mdrun_mpi_d.mpich debian/gromacs-mpich/usr/lib/libgmx_mpi_mpich.so.5.0.0" were not uselessly linked against it (they use none of its symbols).
> dpkg-shlibdeps: warning: dependency on librt.so.1 could be avoided if "debian/gromacs-mpich/usr/lib/libmd_mpi_d_mpich.so.5.0.0 debian/gromacs-mpich/usr/lib/libgmx_mpi_d_mpich.so.5.0.0 debian/gromacs-mpich/usr/lib/libmd_mpi_mpich.so.5.0.0 debian/gromacs-mpich/usr/bin/mdrun_mpi.mpich debian/gromacs-mpich/usr/bin/mdrun_mpi_d.mpich debian/gromacs-mpich/usr/lib/libgmx_mpi_mpich.so.5.0.0" were not uselessly linked against it (they use none of its symbols).
> dh_shlibdeps -pgromacs-openmpi -L gromacs-openmpi -l debian/gromacs-openmpi/usr/lib
> dpkg-shlibdeps: error: couldn't find library libmd_mpi_d_openmpi.so.5 needed by debian/gromacs-openmpi/usr/bin/mdrun_mpi_d.openmpi (ELF format: 'elf64-x86-64'; RPATH: '').
> Note: libraries are not searched in other binary packages that do not have any shlibs or symbols file.
> To help dpkg-shlibdeps find private libraries, you might need to set LD_LIBRARY_PATH.
> dh_shlibdeps: dpkg-shlibdeps returned exit code 2
> make: *** [binary-arch] Error 1
> dpkg-buildpackage: error: /usr/bin/fakeroot debian/rules binary-arch gave error exit status 2

A full build log can be found at:
http://buildd.debian.org/build.php?arch=amd64&pkg=gromacs&ver=4.0.5-2+b1


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debichem Team <debichem-devel@lists.alioth.debian.org>:
Bug#531419; Package gromacs. (Mon, 01 Jun 2009 20:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Breen <nbreen@ofb.net>:
Extra info received and forwarded to list. Copy sent to Debichem Team <debichem-devel@lists.alioth.debian.org>. (Mon, 01 Jun 2009 20:09:03 GMT) Full text and rfc822 format available.

Message #10 received at 531419@bugs.debian.org (full text, mbox):

From: Nicholas Breen <nbreen@ofb.net>
To: Kurt Roeckx <kurt@roeckx.be>, 531419@bugs.debian.org
Subject: Re: [Debichem-devel] Bug#531419: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Mon, 1 Jun 2009 13:02:19 -0700
On Mon, Jun 01, 2009 at 12:57:49PM +0200, Kurt Roeckx wrote:
> Source: gromacs
> Version: 4.0.5-2
> Severity: serious
> 
> Hi,
> 
> There was an error while trying to autobuild your package:
[...]

Looks like another victim of #531184, the MPI update-alternatives bug you filed
on Saturday; should clear itself up once that's resolved.  Thanks for the
report.

(There's a _different_ FTBFS bug on powerpc, but in theory that'll be fixed by
the next gromacs upload...)



-- 
Nicholas Breen
nbreen@ofb.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debichem Team <debichem-devel@lists.alioth.debian.org>:
Bug#531419; Package gromacs. (Mon, 01 Jun 2009 20:27:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debichem Team <debichem-devel@lists.alioth.debian.org>. (Mon, 01 Jun 2009 20:27:02 GMT) Full text and rfc822 format available.

Message #15 received at 531419@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Nicholas Breen <nbreen@ofb.net>
Cc: 531419@bugs.debian.org
Subject: Re: [Debichem-devel] Bug#531419: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Mon, 1 Jun 2009 22:24:12 +0200
On Mon, Jun 01, 2009 at 01:02:19PM -0700, Nicholas Breen wrote:
> On Mon, Jun 01, 2009 at 12:57:49PM +0200, Kurt Roeckx wrote:
> > Source: gromacs
> > Version: 4.0.5-2
> > Severity: serious
> > 
> > Hi,
> > 
> > There was an error while trying to autobuild your package:
> [...]
> 
> Looks like another victim of #531184, the MPI update-alternatives bug you filed
> on Saturday; should clear itself up once that's resolved.  Thanks for the
> report.

I've manually fixed the buildd that had that problem, none of the
other buildds had that problem, and gromacs was build on one
of the other buildds, and that chroot is only 15 days old.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debichem Team <debichem-devel@lists.alioth.debian.org>:
Bug#531419; Package gromacs. (Tue, 02 Jun 2009 02:18:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Breen <nbreen@ofb.net>:
Extra info received and forwarded to list. Copy sent to Debichem Team <debichem-devel@lists.alioth.debian.org>. (Tue, 02 Jun 2009 02:18:02 GMT) Full text and rfc822 format available.

Message #20 received at 531419@bugs.debian.org (full text, mbox):

From: Nicholas Breen <nbreen@ofb.net>
To: 531419@bugs.debian.org
Cc: control@bugs.debian.org, pkg-openmpi-maintainers@lists.alioth.debian.org
Subject: Re: [Debichem-devel] Bug#531419: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Mon, 1 Jun 2009 19:15:21 -0700
clone 531419 -1
reassign -1 libopenmpi-dev
retitle -1 libopenmpi-dev: mpicc segfaults under fakeroot
block 531419 by -1
thanks

Okay, it looks like the root cause is something that's appeared recently in
openmpi - it fails under 1.3.2-2, but works under 1.3-2.  Manuel, I'm cloning
the bug for tracking purposes, but I'm certainly not sure that it's actually an
OpenMPI bug at heart.  Have you seen anything else like this?

% echo "int main(void) { return 0; }" > test.c
% mpicc.openmpi test.c ; echo $?
0
% fakeroot mpicc.openmpi test.c ; echo $?
Segmentation fault
139

No failures with the other MPI implementations, nor with OpenMPI 1.3.  I can
put it under gdb but am missing some debugging libraries in the middle:

% fakeroot gdb mpicc.openmpi
[...]
(gdb) run test.c
Starting program: /usr/bin/mpicc.openmpi conftest.c
[Thread debugging using libthread_db enabled]
[New Thread 0xb7dc46c0 (LWP 6958)]

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 0xb7dc46c0 (LWP 6958)]
__libc_calloc (n=1, elem_size=20) at malloc.c:3932
3932    malloc.c: No such file or directory.
        in malloc.c
(gdb) bt
#0  __libc_calloc (n=1, elem_size=20) at malloc.c:3932
#1  0xb7f83086 in _dlerror_run (operate=0xb7f82d90 <dlsym_doit>, args=0xbfd3002c) at dlerror.c:142
#2  0xb7f82d43 in __dlsym (handle=0xffffffff, name=0xb800f16a "open") at dlsym.c:71
#3  0xb800db73 in load_library_symbols () from /usr/lib/libfakeroot/libfakeroot-sysv.so
#4  0xb800e687 in tmp___xstat () from /usr/lib/libfakeroot/libfakeroot-sysv.so
#5  0xb800daa3 in __xstat () from /usr/lib/libfakeroot/libfakeroot-sysv.so
#6  0xb7fbcefc in ?? () from /usr/lib/libopen-pal.so.0
#7  0x00000003 in ?? ()
#8  0xb7fc948e in ?? () from /usr/lib/libopen-pal.so.0
#9  0xbfd300e4 in ?? ()
#10 0x00001b2e in ?? ()
#11 0xbfd300e4 in ?? ()
#12 0x00000003 in ?? ()
#13 0x00000003 in ?? ()
#14 0xbfd30164 in ?? ()
#15 0xb7f20ff4 in ?? () from /lib/i686/cmov/libc.so.6
#16 0x00000001 in ?? ()
#17 0xb7dc8d0c in ?? () from /lib/i686/cmov/libc.so.6
#18 0xbfd30148 in ?? ()
#19 0xb7ee4429 in *__GI__dl_addr (address=0xb7e34e70, info=0xbfd30184, mapp=0xbfd30194,
    symbolp=0xb7f2260c) at dl-addr.c:146
#20 0xb7e35096 in ptmalloc_init () at arena.c:571
#21 0xb7e386bc in malloc_hook_ini (sz=12, caller=0xb7f939ab) at hooks.c:37
#22 0xb7e38535 in *__GI___libc_malloc (bytes=12) at malloc.c:3546
#23 0xb7f939ab in opal_class_initialize () from /usr/lib/libopen-pal.so.0
#24 0xb7fb3227 in opal_output_init () from /usr/lib/libopen-pal.so.0
#25 0xb7f96205 in opal_init_util () from /usr/lib/libopen-pal.so.0
#26 0x08049b62 in main (argc=2, argv=0xbfd30404) at ../../../../../opal/tools/wrappers/opal_wrapper.c:480

I confess that the peculiar interactions of compilers, fakeroot, and (e)glibc
put me well out of my depth.

-- 
Nicholas Breen
nbreen@ofb.net




Bug 531419 cloned as bug 531522. Request was from Nicholas Breen <nbreen@ofb.net> to control@bugs.debian.org. (Tue, 02 Jun 2009 02:18:03 GMT) Full text and rfc822 format available.

Bug reassigned from package `gromacs' to `libopenmpi-dev'. Request was from Nicholas Breen <nbreen@ofb.net> to control@bugs.debian.org. (Tue, 02 Jun 2009 02:18:05 GMT) Full text and rfc822 format available.

Changed Bug title to `libopenmpi-dev: mpicc segfaults under fakeroot' from `gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5'. Request was from Nicholas Breen <nbreen@ofb.net> to control@bugs.debian.org. (Tue, 02 Jun 2009 02:18:06 GMT) Full text and rfc822 format available.

Blocking bugs of 531419 added: 531522 Request was from Nicholas Breen <nbreen@ofb.net> to control@bugs.debian.org. (Tue, 02 Jun 2009 02:18:07 GMT) Full text and rfc822 format available.

Tags added: confirmed Request was from Manuel Prinz <debian@pinguinkiste.de> to control@bugs.debian.org. (Tue, 02 Jun 2009 20:45:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Tue, 02 Jun 2009 22:33:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Breen <nbreen@ofb.net>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Tue, 02 Jun 2009 22:33:06 GMT) Full text and rfc822 format available.

Message #35 received at 531522@bugs.debian.org (full text, mbox):

From: Nicholas Breen <nbreen@ofb.net>
To: Manuel Prinz <debian@pinguinkiste.de>
Cc: 531419@bugs.debian.org, 531522@bugs.debian.org
Subject: Re: Bug#531419: [Debichem-devel] Bug#531419: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Tue, 2 Jun 2009 15:29:48 -0700
(Adding Cc: #531522, the bug I cloned to openmpi.)

On Tue, Jun 02, 2009 at 11:38:20PM +0200, Manuel Prinz wrote:
> ACK. But from what I see and experienced, I get the feeling that it's
> related to eglibc. Anyway, here is my backtrace (amd64):

Doesn't seem like it was necessarily the eglibc switch, though.  Downgrading to
openmpi 1.3-2 on an otherwise up-to-date sid box doesn't show the bug.
fakeroot 1.12.2, libc6 2.9-13.


- Nicholas





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Wed, 03 Jun 2009 03:03:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Wed, 03 Jun 2009 03:03:06 GMT) Full text and rfc822 format available.

Message #40 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: 531419@bugs.debian.org, 531522@bugs.debian.org
Cc: 531421@bugs.debian.org, 531415@bugs.debian.org
Subject: Some more info
Date: Tue, 2 Jun 2009 21:57:09 -0500
[Message part 1 (text/plain, inline)]
Just FYI:

1. This bug can be demonstrated without a C file:

    > mpicc.openmpi -show
    gcc -I/usr/lib/openmpi/include ... -lnsl -lutil -lm -ldl

    > fakeroot mpicc.openmpi -show
    /usr/bin/fakeroot: line 178: 27191 Segmentation fault      (core dumped) FAKEROOTKEY=...

2. This bug is the root cause of FTBFS for boost: 531421, 531415

-S

[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Wed, 03 Jun 2009 14:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <manuel@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Wed, 03 Jun 2009 14:57:03 GMT) Full text and rfc822 format available.

Message #45 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <manuel@debian.org>
To: Nicholas Breen <nbreen@ofb.net>
Cc: 531419@bugs.debian.org, 531522@bugs.debian.org
Subject: Re: Bug#531419: [Debichem-devel] Bug#531419: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Wed, 03 Jun 2009 16:47:26 +0200
[Message part 1 (text/plain, inline)]
Am Dienstag, den 02.06.2009, 15:29 -0700 schrieb Nicholas Breen:
> Doesn't seem like it was necessarily the eglibc switch, though.  Downgrading to
> openmpi 1.3-2 on an otherwise up-to-date sid box doesn't show the bug.
> fakeroot 1.12.2, libc6 2.9-13.

Interestingly, it works with OpenMPI 1.3.2 on a Lenny box. With Open MPI
1.3.2, libc6 2.7-14, fakeroot 1.10.1 and gcc 4.3.2-1 the error is not
reproducable. So I'm still sceptical if Open MPI is at fault. If it's
not, I still have no clue which of those it is. I'll try Daniel's
suggestion later. But I'm not sure if it's fakeroot since it does not
seem to behave weird with other programs.

Best regards
Manuel
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Wed, 03 Jun 2009 21:06:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <debian@pinguinkiste.de>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Wed, 03 Jun 2009 21:06:05 GMT) Full text and rfc822 format available.

Message #50 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <debian@pinguinkiste.de>
To: Daniel Leidert <daniel.leidert@wgdd.de>
Cc: 531522@bugs.debian.org, 531419@bugs.debian.org
Subject: Re: Bug#531419: gromacs: FTBFS: error: couldn't find library libmd_mpi_d_openmpi.so.5
Date: Wed, 03 Jun 2009 23:02:53 +0200
[Message part 1 (text/plain, inline)]
Hi Daniel!

Am Mittwoch, den 03.06.2009, 00:21 +0200 schrieb Daniel Leidert:
> Hi guys. A short note: After the change to eglibc I discovered
> segmentation faults in the gnome-chemistry-utils (with similar
> backtraces), which were solved by rebuilding the package. It *might*
> help to do the same here: rebuild fakeroot and all related dependencies
> and check, if the segmentation fault(s) still occur(s).

I tried it but it doesn't work. fakeroot seems to be OK. I have the
feeling that the lazy loading and dlopen() is causing that. Open MPI
also brings it's own version of libltdl, so this might be of concern
here. But thanks for your suggestion anyway! :)

Best regards
Manuel
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Thu, 04 Jun 2009 11:33:18 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <manuel@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Thu, 04 Jun 2009 11:33:18 GMT) Full text and rfc822 format available.

Message #55 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <manuel@debian.org>
To: debian-glibc@lists.debian.org
Cc: 531522@bugs.debian.org
Subject: RFH: error in dlopen?
Date: Thu, 04 Jun 2009 13:21:01 +0200
[Message part 1 (text/plain, inline)]
[ Please keep me or the bug in CC, as I'm not subscribed. Thanks! ]

Hi everyone,

I'm trying to find the reason for bug #531522. The Open MPI compiler
wrapper of Open MPI 1.3.2 segfaults when called with fakeroot. I have
the feeling that eglibc's dlopen()/dlsym() might be the problem but I'm
not sure enough to file a bug report. It would be great if someone could
have a look at it and enlighten me. It's blocking the Open MPI
transition and I'm kinda lost at the moment.

As far as I can say, the problem does not appear on a Lenny system with
Open MPI 1.3.2. Before the transition started, I rebuilt all packages
that depend on Open MPI in a sid chroot which worked fine. This was
before the switch to eglibc. This is why I think it might be eglibc
related, and not a problem in Open MPI itself.

I've not found a list of differences between glibc and eglibc that shed
some light into that, so this is why I ask you, the experts. If I can
provide any further information besides the backtraces in the bug log,
please feel free to ask!

Thanks in advance!

Best regards
Manuel
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Thu, 04 Jun 2009 14:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurelien@aurel32.net>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Thu, 04 Jun 2009 14:09:03 GMT) Full text and rfc822 format available.

Message #60 received at 531522@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurelien@aurel32.net>
To: Manuel Prinz <manuel@debian.org>
Cc: 531522@bugs.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>
Subject: Re: RFH: error in dlopen?
Date: Thu, 04 Jun 2009 16:00:55 +0200
Manuel Prinz a écrit :
> [ Please keep me or the bug in CC, as I'm not subscribed. Thanks! ]
> 
> Hi everyone,
> 
> I'm trying to find the reason for bug #531522. The Open MPI compiler
> wrapper of Open MPI 1.3.2 segfaults when called with fakeroot. I have
> the feeling that eglibc's dlopen()/dlsym() might be the problem but I'm
> not sure enough to file a bug report. It would be great if someone could
> have a look at it and enlighten me. It's blocking the Open MPI
> transition and I'm kinda lost at the moment.

Are you able to reproduce the problem without fakeroot?

> As far as I can say, the problem does not appear on a Lenny system with
> Open MPI 1.3.2. Before the transition started, I rebuilt all packages
> that depend on Open MPI in a sid chroot which worked fine. This was
> before the switch to eglibc. This is why I think it might be eglibc
> related, and not a problem in Open MPI itself.
> 
> I've not found a list of differences between glibc and eglibc that shed
> some light into that, so this is why I ask you, the experts. If I can
> provide any further information besides the backtraces in the bug log,
> please feel free to ask!
>

Then just downgrade to glibc to see if the problem disappears. You can
find glibc packages there: http://temp.aurel32.net/www

-- 
Aurelien Jarno	                        GPG: 1024D/F1BCDB73
aurelien@aurel32.net                 http://www.aurel32.net




Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sun, 07 Jun 2009 16:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sun, 07 Jun 2009 16:27:03 GMT) Full text and rfc822 format available.

Message #65 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Jeff Squyres <jsquyres@cisco.com>
Cc: Manuel Prinz <debian@pinguinkiste.de>, Nicholas Breen <nbreen@ofb.net>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org, libc6@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Sun, 7 Jun 2009 11:04:42 -0500
[Message part 1 (text/plain, inline)]
Hi,

Thanks to Jeff's observations, I have a workaround that should suffice
for Debian.  I don't know what the right fix should be, but I hope the
openmpi, fakeroot, and libc6 folks can take it from here.


On Fri, Jun 05, 2009 at 02:39:27PM -0400, Jeff Squyres wrote:
> On Jun 2, 2009, at 4:25 PM, Manuel Prinz wrote:
>
>> I'm putting you in the loop since I'm quite lost here... It would be
>> great if you could throw in your thoughts!
>
> Sorry for the delay in replying; this week has been crazier than most.
>
>> mpicc segfaults when it's called via fakeroot.
>
> What is fakeroot?

A Debian binary package is technically built with root privileges.
Understandably, however, most Debian package maintainers prefer not to
run someone else's source build as root on their machines.  The
utility "fakeroot" uses "LD_PRELOAD and SYSV IPC (or TCP) trickery"
(http://fakeroot.alioth.debian.org/) to provide the illusion of
building with root privileges.

In particular, libc functions like stat() are faked out.


> Ick... I have zero experience with eglibc; this *could* be a  
> compatibility issue...?
>
> In OMPI 1.3.2, we started using the __malloc_initialize_hook  
> functionality to get a function of ours called at the first time the  
> memory allocation subsystem is invoked in a process.  Specifically, we  
> do this:
>
> void (*__malloc_initialize_hook) (void) =
>     opal_memory_ptmalloc2_malloc_init_hook;

Based on this, I took a look at opal_memory_ptmalloc2_malloc_init_hook
and we see:

    /* Look for sentinel files (directories) to see if various network
       drivers are loaded (yes, I know, further abstraction
       violations...).

       * All OpenFabrics devices will have files in
         /sys/class/infiniband (even iWARP)
       * Open-MX doesn't currently use a reg cache, but it might
         someday.  So be conservative and check for /dev/open-mx.
       * MX will have one or more of /dev/myri[0-9].  Yuck.
     */
    if (0 == stat("/sys/class/infiniband", &st) ||
        0 == stat("/dev/open-mx", &st) ||
        0 == stat("/dev/myri0", &st) ||
    [...]

i.e. lots of stat calls.  I was able to avoid the segfault simply by
ifdef'ing out this section (patch attached).  This should suffice in the
short term for Debian on the theory that OpenMPI compatibility with
fakeroot is more important than OpenMPI compatibility with
OpenFabrics.

However, there is clearly a bad interaction between this code, eglibc,
and fakeroot.  Hence the cc's to the various packages.

If we look at the backtrace on a system with most of the debug libs
installed (http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=531419) we
can see the calls from ptmalloc_init() through something in
libopen-pal to __xstat() in fakeroot:

(gdb) bt
#0  __libc_calloc (n=1, elem_size=32) at malloc.c:3932
#1  0x00007f12ca8af380 in _dlerror_run (operate=0x7f12ca8af0c0 <dlsym_doit>, args=0x7fffd314af60) at dlerror.c:142
#2  0x00007f12ca8af07a in __dlsym (handle=<value optimized out>, name=<value optimized out>) at dlsym.c:71
#3  0x00007f12cad2b016 in load_library_symbols () from /usr/lib/libfakeroot/libfakeroot-sysv.so
#4  0x00007f12cad2bc11 in tmp___xstat () from /usr/lib/libfakeroot/libfakeroot-sysv.so
#5  0x00007f12cad2af8d in __xstat () from /usr/lib/libfakeroot/libfakeroot-sysv.so
#6  0x00007f12caaea6dd in ?? () from /usr/lib/libopen-pal.so.0
#7  0x00007f12c9d148e1 in ptmalloc_init () at arena.c:571
#8  0x00007f12c9d18997 in malloc_hook_ini (sz=1, caller=0x20) at hooks.c:37
#9  0x00007f12caac2a95 in opal_class_initialize () from /usr/lib/libopen-pal.so.0
#10 0x00007f12caae0de9 in opal_output_init () from /usr/lib/libopen-pal.so.0
#11 0x00007f12caac52b3 in opal_init_util () from /usr/lib/libopen-pal.so.0
#12 0x0000000000402122 in main (argc=1, argv=0x20) at ../../../../../opal/tools/wrappers/opal_wrapper.c:480
(gdb) 

I'm speculating that memory allocation while in the
__malloc_initialize_hook is a bad thing.  Perhaps the stat() in
fakeroot caused a memory allocation, whereas the regular stat() does
not, as this code doesn't segfault in normal use.

As I say, I hope the more knowledgeable folks can figure this out.
I'm way over my head now. ;-)

Thanks,
-Steve

[diff (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Blocking bugs of 531415 added: 531522 Request was from "Steve M. Robbins" <steve@sumost.ca> to control@bugs.debian.org. (Sun, 07 Jun 2009 18:54:04 GMT) Full text and rfc822 format available.

Blocking bugs of 531421 added: 531522 Request was from "Steve M. Robbins" <steve@sumost.ca> to control@bugs.debian.org. (Sun, 07 Jun 2009 19:30:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sun, 07 Jun 2009 21:54:26 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <debian@pinguinkiste.de>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sun, 07 Jun 2009 21:54:31 GMT) Full text and rfc822 format available.

Message #74 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <debian@pinguinkiste.de>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: Jeff Squyres <jsquyres@cisco.com>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org, libc6@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Sun, 07 Jun 2009 23:51:14 +0200
[Message part 1 (text/plain, inline)]
Hi Jeff and Steve,

thanks a lot for diving into it! It's very appreciated! (I was not able
to access a computer during the last two days, so sorry for being
unresponsive!)

Am Sonntag, den 07.06.2009, 11:04 -0500 schrieb Steve M. Robbins:
> I was able to avoid the segfault simply by ifdef'ing out this section
> (patch attached).  This should suffice in the short term for Debian on
> the theory that OpenMPI compatibility with fakeroot is more important
> than OpenMPI compatibility with OpenFabrics.

This is very hard to decide. Of course, we need Open MPI to work with
fakeroot, since our build system relies on that. There's no way around
that. As for OpenFabrics, probably most users will use MPI over fast
interconnects, so we really do need InfiniBand support as well. With the
transition in mind, I would consider disabling InfiniBand as a
short-term and temporary option.

Nevertheless, I will do some more tests tomorrow, hoping to find a less
drastic solution. Jeff's suggestion to disable libltdl sounds like a
reasonable thing. As it seems, we should probably disable it anyway
since Open MPI brings it's own copy and does not allow to build against
a version already installed on the system. Jeff, can you confirm that?

(Currently, the versions of libltdl of Open MPI and Debian seem to
differ. Though might not be the reason, it might mean some extra work
for the release and/or security team.)

> However, there is clearly a bad interaction between this code, eglibc,
> and fakeroot.  Hence the cc's to the various packages.

Thanks for putting them in the loop! I already sent a mail to the libc
maintainers a view days ago but did not test with a downgraded libc.

> I'm speculating that memory allocation while in the
> __malloc_initialize_hook is a bad thing.  Perhaps the stat() in
> fakeroot caused a memory allocation, whereas the regular stat() does
> not, as this code doesn't segfault in normal use.

This is what I had in mind as well.

Thanks for your work so far! I'm quite confident that we can sort it out
soon! :)

Best regards
Manuel
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Mon, 08 Jun 2009 10:24:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Jeff Squyres (jsquyres)" <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Mon, 08 Jun 2009 10:24:07 GMT) Full text and rfc822 format available.

Message #79 received at 531522@bugs.debian.org (full text, mbox):

From: "Jeff Squyres (jsquyres)" <jsquyres@cisco.com>
To: <debian@pinguinkiste.de>, <steve@sumost.ca>
Cc: <531419@bugs.debian.org>, <531522@bugs.debian.org>, <fakeroot@packages.debian.org>, <libc6@packages.debian.org>
Subject: Re: mpicc segfaults when called by fakeroot
Date: Mon, 8 Jun 2009 06:13:56 -0400
[Message part 1 (text/plain, inline)]
I'm afk atm and can't see the full bug so far - yes, we should definitely not be aling anyflvor of alloc in the malloc init hook (eg via stat). 

Is there a run-time way to tell if we're running under fakeroot?  We can certainly just disable the malloc init hook if it detects that its under fakeroot. 

Also, we use our own libltdl because we require advanced features that are not always avail in the sys-instaled ltdl (eg installed ver is too old). There should be no conflict from our ltfdl and the sys installed one. Disabling it can be good atscale (eg dozens of machines in a single mpi job - see faq) and for debugging. 

I'll be back in range in several hours (boarding a floight right now). 

-jms
Sent from my PDA.  No type good.

----- Original Message -----
From: Manuel Prinz <debian@pinguinkiste.de>
To: Steve M. Robbins <steve@sumost.ca>
Cc: Jeff Squyres (jsquyres); 531419@bugs.debian.org <531419@bugs.debian.org>; 531522@bugs.debian.org <531522@bugs.debian.org>; fakeroot@packages.debian.org <fakeroot@packages.debian.org>; libc6@packages.debian.org <libc6@packages.debian.org>
Sent: Sun Jun 07 17:51:14 2009
Subject: Re: mpicc segfaults when called by fakeroot

Hi Jeff and Steve,

thanks a lot for diving into it! It's very appreciated! (I was not able
to access a computer during the last two days, so sorry for being
unresponsive!)

Am Sonntag, den 07.06.2009, 11:04 -0500 schrieb Steve M. Robbins:
> I was able to avoid the segfault simply by ifdef'ing out this section
> (patch attached).  This should suffice in the short term for Debian on
> the theory that OpenMPI compatibility with fakeroot is more important
> than OpenMPI compatibility with OpenFabrics.

This is very hard to decide. Of course, we need Open MPI to work with
fakeroot, since our build system relies on that. There's no way around
that. As for OpenFabrics, probably most users will use MPI over fast
interconnects, so we really do need InfiniBand support as well. With the
transition in mind, I would consider disabling InfiniBand as a
short-term and temporary option.

Nevertheless, I will do some more tests tomorrow, hoping to find a less
drastic solution. Jeff's suggestion to disable libltdl sounds like a
reasonable thing. As it seems, we should probably disable it anyway
since Open MPI brings it's own copy and does not allow to build against
a version already installed on the system. Jeff, can you confirm that?

(Currently, the versions of libltdl of Open MPI and Debian seem to
differ. Though might not be the reason, it might mean some extra work
for the release and/or security team.)

> However, there is clearly a bad interaction between this code, eglibc,
> and fakeroot.  Hence the cc's to the various packages.

Thanks for putting them in the loop! I already sent a mail to the libc
maintainers a view days ago but did not test with a downgraded libc.

> I'm speculating that memory allocation while in the
> __malloc_initialize_hook is a bad thing.  Perhaps the stat() in
> fakeroot caused a memory allocation, whereas the regular stat() does
> not, as this code doesn't segfault in normal use.

This is what I had in mind as well.

Thanks for your work so far! I'm quite confident that we can sort it out
soon! :)

Best regards
Manuel
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Mon, 08 Jun 2009 14:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Clint Adams <schizo@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Mon, 08 Jun 2009 14:33:04 GMT) Full text and rfc822 format available.

Message #84 received at 531522@bugs.debian.org (full text, mbox):

From: Clint Adams <schizo@debian.org>
To: "Jeff Squyres (jsquyres)" <jsquyres@cisco.com>
Cc: debian@pinguinkiste.de, steve@sumost.ca, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org, libc6@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Mon, 8 Jun 2009 14:20:00 +0000
On Mon, Jun 08, 2009 at 06:13:56AM -0400, Jeff Squyres (jsquyres) wrote:
> Is there a run-time way to tell if we're running under fakeroot?  We can certainly just disable the malloc init hook if it detects that its under fakeroot. 

You can use an undocumented API feature to detect/disable fakeroot
temporarily (see the bottom of this message:

http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=15;att=0;bug=224030

) or you can look for environmental variables being set.

Fixing the root cause is probably preferable, though I don't have
much time to look at it myself.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Mon, 08 Jun 2009 20:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Mon, 08 Jun 2009 20:21:06 GMT) Full text and rfc822 format available.

Message #89 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: Manuel Prinz <debian@pinguinkiste.de>
Cc: "Steve M. Robbins" <steve@sumost.ca>, <531419@bugs.debian.org>, <531522@bugs.debian.org>, <fakeroot@packages.debian.org>, <libc6@packages.debian.org>
Subject: Re: mpicc segfaults when called by fakeroot
Date: Mon, 8 Jun 2009 08:09:43 -0400
Further thought: if it's not possible to run-time detect that we're  
running in fakeroot, perhaps an environment variable could be set  
before OMPI's mpicc is launched in the fakeroot so that we can see in  
the malloc hook init that that variable exists and therefore dump out  
before the stat's...?  (i.e., effectively provide our own way to know  
that we're running in fakeroot, and therefore disable all of ompi's  
malloc init/openfabrics/etc. infrastructure, because OpenFabrics  
support is *not* required in fakeroot).

In short: perhaps you could setenv OMPI_MCA_disable_memory_allocator  
to 1, or somesuch.  I can easily provide you with a patch (that we'd  
then also commit upstream, but you'll need the patch until we include  
this feature in a release) for such a fix.

Is that too ugly?



On Jun 7, 2009, at 5:51 PM, Manuel Prinz wrote:

> Hi Jeff and Steve,
>
> thanks a lot for diving into it! It's very appreciated! (I was not  
> able
> to access a computer during the last two days, so sorry for being
> unresponsive!)
>
> Am Sonntag, den 07.06.2009, 11:04 -0500 schrieb Steve M. Robbins:
>> I was able to avoid the segfault simply by ifdef'ing out this section
>> (patch attached).  This should suffice in the short term for Debian  
>> on
>> the theory that OpenMPI compatibility with fakeroot is more important
>> than OpenMPI compatibility with OpenFabrics.
>
> This is very hard to decide. Of course, we need Open MPI to work with
> fakeroot, since our build system relies on that. There's no way around
> that. As for OpenFabrics, probably most users will use MPI over fast
> interconnects, so we really do need InfiniBand support as well. With  
> the
> transition in mind, I would consider disabling InfiniBand as a
> short-term and temporary option.
>
> Nevertheless, I will do some more tests tomorrow, hoping to find a  
> less
> drastic solution. Jeff's suggestion to disable libltdl sounds like a
> reasonable thing. As it seems, we should probably disable it anyway
> since Open MPI brings it's own copy and does not allow to build  
> against
> a version already installed on the system. Jeff, can you confirm that?
>
> (Currently, the versions of libltdl of Open MPI and Debian seem to
> differ. Though might not be the reason, it might mean some extra work
> for the release and/or security team.)
>
>> However, there is clearly a bad interaction between this code,  
>> eglibc,
>> and fakeroot.  Hence the cc's to the various packages.
>
> Thanks for putting them in the loop! I already sent a mail to the libc
> maintainers a view days ago but did not test with a downgraded libc.
>
>> I'm speculating that memory allocation while in the
>> __malloc_initialize_hook is a bad thing.  Perhaps the stat() in
>> fakeroot caused a memory allocation, whereas the regular stat() does
>> not, as this code doesn't segfault in normal use.
>
> This is what I had in mind as well.
>
> Thanks for your work so far! I'm quite confident that we can sort it  
> out
> soon! :)
>
> Best regards
> Manuel


-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Tue, 09 Jun 2009 04:12:35 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Tue, 09 Jun 2009 04:13:04 GMT) Full text and rfc822 format available.

Message #94 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: Clint Adams <schizo@debian.org>
Cc: <debian@pinguinkiste.de>, <steve@sumost.ca>, <531419@bugs.debian.org>, <531522@bugs.debian.org>, <fakeroot@packages.debian.org>, <libc6@packages.debian.org>
Subject: Re: mpicc segfaults when called by fakeroot
Date: Mon, 8 Jun 2009 21:08:40 -0700
On Jun 8, 2009, at 7:20 AM, Clint Adams wrote:

> > Is there a run-time way to tell if we're running under fakeroot?   
> We can certainly just disable the malloc init hook if it detects  
> that its under fakeroot.
>
> You can use an undocumented API feature to detect/disable fakeroot
> temporarily (see the bottom of this message:
>
> http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=15;att=0;bug=224030
>
> ) or you can look for environmental variables being set.
>
> Fixing the root cause is probably preferable, though I don't have
> much time to look at it myself.
>

Agreed; fixing the root problem is a better bet.

Manuel -- can you ping the fakeroot people?  It would be preferable to  
the method described in that URL.

-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Tue, 09 Jun 2009 23:36:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <debian@pinguinkiste.de>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Tue, 09 Jun 2009 23:36:05 GMT) Full text and rfc822 format available.

Message #99 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <debian@pinguinkiste.de>
To: Jeff Squyres <jsquyres@cisco.com>, 531419@bugs.debian.org
Cc: Clint Adams <schizo@debian.org>, steve@sumost.ca, 531522@bugs.debian.org, fakeroot@packages.debian.org, libc6@packages.debian.org
Subject: Re: Bug#531419: mpicc segfaults when called by fakeroot
Date: Wed, 10 Jun 2009 01:28:09 +0200
[Message part 1 (text/plain, inline)]
Hi Jeff!

Am Montag, den 08.06.2009, 21:08 -0700 schrieb Jeff Squyres:
> Agreed; fixing the root problem is a better bet.
> 
> Manuel -- can you ping the fakeroot people?  It would be preferable to  
> the method described in that URL.

The fakeroot maintainers are in CC, they should have gotten the last
message of yours.

As for the root cause, I'm still puzzled. I tested it today with the
most recent eglic (2.9-13) and an older glibc (2.9-10) provided by
Aurelien Jarno against almost all versions of fakeroot available on
snapshort.debian.net. Segfaults with all combinations. On the other
hand, as I wrote in message #45, it seems to work fine on my Lenny box
which has glibc 2.7-18. I will test this version on my unstable box
tomorrow. For some reason, fakeroot and Open MPI 1.3.2 don't show issues
in the versions in Lenny. I'll also test the fakeroot version in
unstable on my Lenny box tomorrow. Not sure if this brings any insight,
though.

Best regards
Manuel
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Wed, 10 Jun 2009 12:06:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <manuel@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Wed, 10 Jun 2009 12:06:05 GMT) Full text and rfc822 format available.

Message #104 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <manuel@debian.org>
To: 531419@bugs.debian.org, 531522@bugs.debian.org
Cc: Jeff Squyres <jsquyres@cisco.com>, fakeroot@packages.debian.org, libc6@packages.debian.org
Subject: Re: Bug#531419: mpicc segfaults when called by fakeroot
Date: Wed, 10 Jun 2009 13:59:41 +0200
Checked again, the bug is somewhere in Open MPI. While testing on Lenny,
I had some cruft left over. A fresh 1.3.2 installation shows the same
behaviour.

Best regards
Manuel






Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Fri, 12 Jun 2009 08:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Fri, 12 Jun 2009 08:45:03 GMT) Full text and rfc822 format available.

Message #109 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Manuel Prinz <manuel@debian.org>, 531522@bugs.debian.org
Cc: 531419@bugs.debian.org, Jeff Squyres <jsquyres@cisco.com>, fakeroot@packages.debian.org, libc6@packages.debian.org
Subject: Re: Bug#531522: Bug#531419: mpicc segfaults when called by fakeroot
Date: Fri, 12 Jun 2009 03:44:36 -0500
[Message part 1 (text/plain, inline)]
On Wed, Jun 10, 2009 at 01:59:41PM +0200, Manuel Prinz wrote:
> Checked again, the bug is somewhere in Open MPI. While testing on Lenny,
> I had some cruft left over. A fresh 1.3.2 installation shows the same
> behaviour.

OK, so where do we go from here?

It seems to me that OpenMPI is at fault for doing crafty things like
"stat()" in the __malloc_initialize_hook().  If that is the accepted
view, then having a way to suppress this behaviour, say with an
environment variable as suggested by Jeff Squyres, seems appropriate.
That would let me solve my problem by setting the variable in
debian/rules.  Or we could solve it Debian-wide by having
the variable set by fakeroot.

Thoughts?

-Steve
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sat, 13 Jun 2009 02:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sat, 13 Jun 2009 02:45:03 GMT) Full text and rfc822 format available.

Message #114 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: "Manuel Prinz" <manuel@debian.org>, <531522@bugs.debian.org>, <531419@bugs.debian.org>, <fakeroot@packages.debian.org>, <libc6@packages.debian.org>
Subject: Re: Bug#531522: Bug#531419: mpicc segfaults when called by fakeroot
Date: Fri, 12 Jun 2009 14:10:11 -0700
Agreed.  We thought that stat() was safe to call in the malloc init  
hook -- it seems to be in most other places, at least.

If there's some other safe way to check that stat() is *not* safe,  
that would be great.


On Jun 12, 2009, at 1:44 AM, Steve M. Robbins wrote:

> On Wed, Jun 10, 2009 at 01:59:41PM +0200, Manuel Prinz wrote:
>> Checked again, the bug is somewhere in Open MPI. While testing on  
>> Lenny,
>> I had some cruft left over. A fresh 1.3.2 installation shows the same
>> behaviour.
>
> OK, so where do we go from here?
>
> It seems to me that OpenMPI is at fault for doing crafty things like
> "stat()" in the __malloc_initialize_hook().  If that is the accepted
> view, then having a way to suppress this behaviour, say with an
> environment variable as suggested by Jeff Squyres, seems appropriate.
> That would let me solve my problem by setting the variable in
> debian/rules.  Or we could solve it Debian-wide by having
> the variable set by fakeroot.
>
> Thoughts?
>
> -Steve


-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sun, 14 Jun 2009 15:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Manuel Prinz" <debian@pinguinkiste.de>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sun, 14 Jun 2009 15:12:04 GMT) Full text and rfc822 format available.

Message #119 received at 531522@bugs.debian.org (full text, mbox):

From: "Manuel Prinz" <debian@pinguinkiste.de>
To: "Jeff Squyres" <jsquyres@cisco.com>, 531522@bugs.debian.org
Cc: "Steve M. Robbins" <steve@sumost.ca>, 531419@bugs.debian.org
Subject: Re: [Pkg-openmpi-maintainers] Bug#531522: Bug#531419: mpicc segfaults when called by fakeroot
Date: Sun, 14 Jun 2009 17:10:46 +0200
Hi everyone!

On Fri, June 12, 2009 11:10 pm, Jeff Squyres wrote:
> Agreed.  We thought that stat() was safe to call in the malloc init
> hook -- it seems to be in most other places, at least.
>
> If there's some other safe way to check that stat() is *not* safe,
> that would be great.

Unfortunately, I will not be able to use the internet for a week from now.
This means that I can't help fixing the issue. I'm very sorry about that!

I hope Sylvestre can take over. If one wants to (or can) work out a fix,
feel free to NMU. I'm OK with 0-day NMUs for this case. The release team
also needs to be informed about the upload to schedule rebuilds again.
Sylvestre should be able to upload, though he is not a DD yet. But I guess
you guys can work it out.

I'm sorry for the situation and the delay it may cause! I will get back to
it as soon as I am back again.

Best regards
Manuel





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sun, 14 Jun 2009 16:24:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sun, 14 Jun 2009 16:24:04 GMT) Full text and rfc822 format available.

Message #124 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Manuel Prinz <debian@pinguinkiste.de>, sylvestre.ledru@inria.fr
Cc: Jeff Squyres <jsquyres@cisco.com>, 531522@bugs.debian.org, 531419@bugs.debian.org
Subject: Re: [Pkg-openmpi-maintainers] Bug#531522: Bug#531419: mpicc segfaults when called by fakeroot
Date: Sun, 14 Jun 2009 11:19:57 -0500
[Message part 1 (text/plain, inline)]
On Sun, Jun 14, 2009 at 05:10:46PM +0200, Manuel Prinz wrote:
> Hi everyone!
> 
> On Fri, June 12, 2009 11:10 pm, Jeff Squyres wrote:
> > Agreed.  We thought that stat() was safe to call in the malloc init
> > hook -- it seems to be in most other places, at least.

Jeff, I agree that one would expect stat() to be safe; my comment
about "crafty things" wasn't intended as a judgement call on this
approach.  I think the code is pretty clever, but it's a hard problem
when you are operating with no clear rules about what is permitted in
the init hook.  :-)


> Unfortunately, I will not be able to use the internet for a week from now.
> This means that I can't help fixing the issue. I'm very sorry about that!
> 
> I hope Sylvestre can take over. If one wants to (or can) work out a fix,
> feel free to NMU. 

If Sylvestre wants to upload a fix, that's perfect.

Otherwise, I can easily convert my "#if 0" hack into a patch that
checks for an environment variable.  Jeff previously suggested
setting OMPI_MCA_disable_memory_allocator; is that the variable we
want to use?


Regards,
-Steve
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Mon, 15 Jun 2009 09:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sylvestre Ledru <sylvestre.ledru@inria.fr>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Mon, 15 Jun 2009 09:12:04 GMT) Full text and rfc822 format available.

Message #129 received at 531522@bugs.debian.org (full text, mbox):

From: Sylvestre Ledru <sylvestre.ledru@inria.fr>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: Manuel Prinz <debian@pinguinkiste.de>, Jeff Squyres <jsquyres@cisco.com>, 531522@bugs.debian.org, 531419@bugs.debian.org
Subject: Re: [Pkg-openmpi-maintainers] Bug#531522: Bug#531419: mpicc segfaults when called by fakeroot
Date: Mon, 15 Jun 2009 11:08:54 +0200
Hello guys,

Le dimanche 14 juin 2009 à 11:19 -0500, Steve M. Robbins a écrit :
> On Sun, Jun 14, 2009 at 05:10:46PM +0200, Manuel Prinz wrote:
> > Hi everyone!
> > 
> > On Fri, June 12, 2009 11:10 pm, Jeff Squyres wrote:
> > > Agreed.  We thought that stat() was safe to call in the malloc init
> > > hook -- it seems to be in most other places, at least.
> 
> Jeff, I agree that one would expect stat() to be safe; my comment
> about "crafty things" wasn't intended as a judgement call on this
> approach.  I think the code is pretty clever, but it's a hard problem
> when you are operating with no clear rules about what is permitted in
> the init hook.  :-)
> 
> 
> > Unfortunately, I will not be able to use the internet for a week from now.
> > This means that I can't help fixing the issue. I'm very sorry about that!
> > 
> > I hope Sylvestre can take over. If one wants to (or can) work out a fix,
> > feel free to NMU. 
> 
> If Sylvestre wants to upload a fix, that's perfect.
> Otherwise, I can easily convert my "#if 0" hack into a patch that
> checks for an environment variable.  Jeff previously suggested
> setting OMPI_MCA_disable_memory_allocator; is that the variable we
> want to use?

I am only following the bug report. I haven't dig enough to be able to
fix it right now. Therefor, if someone provides a patch, I will be happy
to upload OpenMPI with the fix/workaround. Otherwise, I will try to find
some time to fix it.

Sylvestre






Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Mon, 15 Jun 2009 15:42:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Mon, 15 Jun 2009 15:42:08 GMT) Full text and rfc822 format available.

Message #134 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: "Manuel Prinz" <debian@pinguinkiste.de>, <sylvestre.ledru@inria.fr>, <531522@bugs.debian.org>, <531419@bugs.debian.org>
Subject: Re: [Pkg-openmpi-maintainers] Bug#531522: Bug#531419: mpiccsegfaults when called by fakeroot
Date: Mon, 15 Jun 2009 11:31:11 -0400
On Jun 14, 2009, at 12:19 PM, Steve M. Robbins wrote:

>>> Agreed.  We thought that stat() was safe to call in the malloc init
>>> hook -- it seems to be in most other places, at least.
>
> Jeff, I agree that one would expect stat() to be safe; my comment
> about "crafty things" wasn't intended as a judgement call on this
> approach.  I think the code is pretty clever, but it's a hard problem
> when you are operating with no clear rules about what is permitted in
> the init hook.  :-)

Thanks!  Just wanted to make sure we weren't unintentionally going  
afoul of some established techniques that we weren't previously aware  
of (wouldn't be the first time :-( ).

> Otherwise, I can easily convert my "#if 0" hack into a patch that
> checks for an environment variable.  Jeff previously suggested
> setting OMPI_MCA_disable_memory_allocator; is that the variable we
> want to use?


Note that this would be a fairly Open MPI-specific environment  
variable.  This would be fine with me, but I don't know you want a  
more generic fakeroot solution in case anyone else ever runs into this  
problem...?

-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Thu, 18 Jun 2009 03:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Thu, 18 Jun 2009 03:33:12 GMT) Full text and rfc822 format available.

Message #139 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: 531522@bugs.debian.org
Subject: NMU diff
Date: Wed, 17 Jun 2009 22:32:09 -0500
[Message part 1 (text/plain, inline)]
Hi,

I'm preparing an NMU with the attached patch to fix this issue.

Thanks,
-Steve


[diff (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Reply sent to smr@debian.org (Steve M. Robbins):
You have taken responsibility. (Thu, 18 Jun 2009 05:36:06 GMT) Full text and rfc822 format available.

Notification sent to Kurt Roeckx <kurt@roeckx.be>:
Bug acknowledged by developer. (Thu, 18 Jun 2009 05:36:06 GMT) Full text and rfc822 format available.

Message #144 received at 531522-close@bugs.debian.org (full text, mbox):

From: smr@debian.org (Steve M. Robbins)
To: 531522-close@bugs.debian.org
Subject: Bug#531522: fixed in openmpi 1.3.2-2.1
Date: Thu, 18 Jun 2009 05:17:10 +0000
Source: openmpi
Source-Version: 1.3.2-2.1

We believe that the bug you reported is fixed in the latest version of
openmpi, which is due to be installed in the Debian FTP archive:

libopenmpi-dbg_1.3.2-2.1_amd64.deb
  to pool/main/o/openmpi/libopenmpi-dbg_1.3.2-2.1_amd64.deb
libopenmpi-dev_1.3.2-2.1_amd64.deb
  to pool/main/o/openmpi/libopenmpi-dev_1.3.2-2.1_amd64.deb
libopenmpi1.3_1.3.2-2.1_amd64.deb
  to pool/main/o/openmpi/libopenmpi1.3_1.3.2-2.1_amd64.deb
openmpi-bin_1.3.2-2.1_amd64.deb
  to pool/main/o/openmpi/openmpi-bin_1.3.2-2.1_amd64.deb
openmpi-common_1.3.2-2.1_all.deb
  to pool/main/o/openmpi/openmpi-common_1.3.2-2.1_all.deb
openmpi-doc_1.3.2-2.1_all.deb
  to pool/main/o/openmpi/openmpi-doc_1.3.2-2.1_all.deb
openmpi_1.3.2-2.1.diff.gz
  to pool/main/o/openmpi/openmpi_1.3.2-2.1.diff.gz
openmpi_1.3.2-2.1.dsc
  to pool/main/o/openmpi/openmpi_1.3.2-2.1.dsc



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 531522@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Steve M. Robbins <smr@debian.org> (supplier of updated openmpi package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 17 Jun 2009 22:03:31 -0500
Source: openmpi
Binary: openmpi-bin libopenmpi-dev libopenmpi1.3 openmpi-common openmpi-doc libopenmpi-dbg
Architecture: source amd64 all
Version: 1.3.2-2.1
Distribution: unstable
Urgency: low
Maintainer: Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>
Changed-By: Steve M. Robbins <smr@debian.org>
Description: 
 libopenmpi-dbg - high performance message passing library -- debug library
 libopenmpi-dev - high performance message passing library -- header files
 libopenmpi1.3 - high performance message passing library -- shared library
 openmpi-bin - high performance message passing library -- binaries
 openmpi-common - high performance message passing library -- common files
 openmpi-doc - high performance message passing library -- man pages
Closes: 531522
Changes: 
 openmpi (1.3.2-2.1) unstable; urgency=low
 .
   * NMU
   * opal/mca/memory/ptmalloc2/hooks.c: Add check for environment variable
     OMPI_MCA_disable_memory_allocator.  If set, avoid setting up malloc
     hooks and avoid stat() calls from the malloc init hook.
     Closes: #531522.
Checksums-Sha1: 
 b005208fce05862958478b565e8fbc7b07e3ec98 1544 openmpi_1.3.2-2.1.dsc
 2b4166168f1cc54282ed7be1eb04c6b589baeb44 20572 openmpi_1.3.2-2.1.diff.gz
 af8d7ac8bbe7bd6d6b50281ec5ccbb62a8fec20f 136200 openmpi-bin_1.3.2-2.1_amd64.deb
 a221bb2cb7afada6268c726f4869ad1e1158b547 2566282 libopenmpi-dev_1.3.2-2.1_amd64.deb
 69e4413166336d41db44d3b4f80ce8a0c9a1e083 1251992 libopenmpi1.3_1.3.2-2.1_amd64.deb
 94d72bf92cc588a2dfac4ae0213e304e14c5a529 5311632 libopenmpi-dbg_1.3.2-2.1_amd64.deb
 343bff71a9247b095b932ae97c444f4596857e92 77044 openmpi-common_1.3.2-2.1_all.deb
 1d09e1376593ceb1f3e33656a7e6f2b76f43b5cc 461922 openmpi-doc_1.3.2-2.1_all.deb
Checksums-Sha256: 
 eb1dab6211724d4e908c6536f399b9724fe1fa08e3a7f74a84880a4901d90fe6 1544 openmpi_1.3.2-2.1.dsc
 3156c932a7586fe3b5b4f70d1cc15be4587a675e4853b92c8264d5d378443ec7 20572 openmpi_1.3.2-2.1.diff.gz
 0b757c62b8c36dd0167bfabd46b6a7c41fc1bc65a7e7ae94cc07d0574800ce8f 136200 openmpi-bin_1.3.2-2.1_amd64.deb
 eea4e22aa7344a4cbb7704d0f2f3911286d058985f4af46ec8100a21c66f2788 2566282 libopenmpi-dev_1.3.2-2.1_amd64.deb
 712e1f1687187a1a31028432716700cf4a2c6d6d8ba26802752a1ef4d1ad0445 1251992 libopenmpi1.3_1.3.2-2.1_amd64.deb
 94f2b8f62aa5d123509fe4656c8f8da3a838645534923ce21e06b249a911fbb7 5311632 libopenmpi-dbg_1.3.2-2.1_amd64.deb
 927fa9064379244273046caf455e25cf372e672811598db57f235ee321e3a2cc 77044 openmpi-common_1.3.2-2.1_all.deb
 1b645de6a47afc8c3c03d25836b80bd544898c0382663f30c36722a41dd2c7e7 461922 openmpi-doc_1.3.2-2.1_all.deb
Files: 
 6633af4595819fe8133f4da6578f72ca 1544 net extra openmpi_1.3.2-2.1.dsc
 f0b17362d84843a45287a053cf5becaa 20572 net extra openmpi_1.3.2-2.1.diff.gz
 13ea5db75a123706a3b33fb82308c1f8 136200 net extra openmpi-bin_1.3.2-2.1_amd64.deb
 32844c6d062ca07ea376f9c5733c53a3 2566282 libdevel extra libopenmpi-dev_1.3.2-2.1_amd64.deb
 78dd9f37fb269df1f19e8d6519233058 1251992 libs extra libopenmpi1.3_1.3.2-2.1_amd64.deb
 e951c830289612c97654b4d8dd45eb02 5311632 debug extra libopenmpi-dbg_1.3.2-2.1_amd64.deb
 6c55fc474f1ad32f1ef110343383a311 77044 net extra openmpi-common_1.3.2-2.1_all.deb
 10ab2c4643ca020eb7766b8b169088d4 461922 doc extra openmpi-doc_1.3.2-2.1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iD8DBQFKOcvQ0i2bPSHbMcURAh1YAKCCahC3lOwq9s5TAuWGfr07b3MxPwCeKdVf
b/ppJkaHRexmQcaA1pY9lt0=
=PkA8
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Fri, 19 Jun 2009 02:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Fri, 19 Jun 2009 02:03:06 GMT) Full text and rfc822 format available.

Message #149 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Jeff Squyres <jsquyres@cisco.com>
Cc: Manuel Prinz <debian@pinguinkiste.de>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Thu, 18 Jun 2009 20:59:29 -0500
[Message part 1 (text/plain, inline)]
Hi all,

On Mon, Jun 08, 2009 at 08:09:43AM -0400, Jeff Squyres wrote:

> In short: perhaps you could setenv OMPI_MCA_disable_memory_allocator to 
> 1, or somesuch.  I can easily provide you with a patch (that we'd then 
> also commit upstream, but you'll need the patch until we include this 
> feature in a release) for such a fix.

I uploaded this change to Debian's openmpi packages yesterday, patch below.
Jeff: will you commit this upstream?

Fakeroot maintainer: will you set OMPI_MCA_disable_memory_allocator to 1
in the fakeroot environment?

Thanks,
-Steve


diff -u -r openmpi-1.3.2/opal/mca/memory/ptmalloc2/hooks.c ../openmpi-1.3.2/opal/mca/memory/ptmalloc2/hooks.c
--- openmpi-1.3.2/opal/mca/memory/ptmalloc2/hooks.c	2009-04-21 22:51:03.000000000 -0500
+++ ../openmpi-1.3.2/opal/mca/memory/ptmalloc2/hooks.c	2009-06-17 21:55:54.000000000 -0500
@@ -725,6 +725,14 @@
     check_result_t lpp = check("OMPI_MCA_mpi_leave_pinned_pipeline");
     bool want_rcache = false, found_driver = false;
 
+    /* Allow user to disable memory allocators.  We check this and
+     * exit early because in some environments (e.g. Debian fakeroot
+     * the stat() calls below will cause a memory allocation, which
+     * is deadly.  See http://bugs.debian.org/531522
+     */
+    if ( RESULT_YES == check("OMPI_MCA_disable_memory_allocator") )
+	return;
+
     /* Look for sentinel files (directories) to see if various network
        drivers are loaded (yes, I know, further abstraction
        violations...).
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Fri, 19 Jun 2009 02:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Clint Adams <schizo@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Fri, 19 Jun 2009 02:12:03 GMT) Full text and rfc822 format available.

Message #154 received at 531522@bugs.debian.org (full text, mbox):

From: Clint Adams <schizo@debian.org>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: Jeff Squyres <jsquyres@cisco.com>, Manuel Prinz <debian@pinguinkiste.de>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Fri, 19 Jun 2009 02:08:45 +0000
On Thu, Jun 18, 2009 at 08:59:29PM -0500, Steve M. Robbins wrote:
> I uploaded this change to Debian's openmpi packages yesterday, patch below.
> Jeff: will you commit this upstream?
> 
> Fakeroot maintainer: will you set OMPI_MCA_disable_memory_allocator to 1
> in the fakeroot environment?

Perhaps it would be better if you had debian/rules check to see if $FAKEROOTKEY is set and
then export OMPI_MCA_disable_memory_allocator in that case.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Fri, 19 Jun 2009 02:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Fri, 19 Jun 2009 02:27:04 GMT) Full text and rfc822 format available.

Message #159 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Clint Adams <schizo@debian.org>
Cc: Jeff Squyres <jsquyres@cisco.com>, Manuel Prinz <debian@pinguinkiste.de>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Thu, 18 Jun 2009 21:24:47 -0500
[Message part 1 (text/plain, inline)]
Hi Clint,

On Fri, Jun 19, 2009 at 02:08:45AM +0000, Clint Adams wrote:
> On Thu, Jun 18, 2009 at 08:59:29PM -0500, Steve M. Robbins wrote:
> > I uploaded this change to Debian's openmpi packages yesterday, patch below.
> > Jeff: will you commit this upstream?
> > 
> > Fakeroot maintainer: will you set OMPI_MCA_disable_memory_allocator to 1
> > in the fakeroot environment?
> 
> Perhaps it would be better if you had debian/rules check to see if
> $FAKEROOTKEY is set and then export
> OMPI_MCA_disable_memory_allocator in that case.

Perhaps, though I don't see any benefit to this approach rather than
always setting the variable.  Can you elaborate?

I'm building a version of boost with OMPI_MCA_disable_memory_allocator=1
set in debian/rules.  There's at least one more FTBFS bug that would
need to do this, which is a very nonobvious workaround to a build
failure.  Wouldn't it be better to have fakeroot set the variable 
and fix the problem in one place?

Regards,
-Steve
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Fri, 19 Jun 2009 11:00:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Fri, 19 Jun 2009 11:00:12 GMT) Full text and rfc822 format available.

Message #164 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: "Clint Adams" <schizo@debian.org>, "Manuel Prinz" <debian@pinguinkiste.de>, <531419@bugs.debian.org>, <531522@bugs.debian.org>, <fakeroot@packages.debian.org>
Subject: Re: mpicc segfaults when called by fakeroot
Date: Fri, 19 Jun 2009 06:52:03 -0400
On Jun 18, 2009, at 10:24 PM, Steve M. Robbins wrote:

>>> I uploaded this change to Debian's openmpi packages yesterday,  
>>> patch below.
>>> Jeff: will you commit this upstream?
>>>
>>> Fakeroot maintainer: will you set  
>>> OMPI_MCA_disable_memory_allocator to 1
>>> in the fakeroot environment?
>>
>> Perhaps it would be better if you had debian/rules check to see if
>> $FAKEROOTKEY is set and then export
>> OMPI_MCA_disable_memory_allocator in that case.
>
> Perhaps, though I don't see any benefit to this approach rather than
> always setting the variable.  Can you elaborate?


Two things:

1. Doh; I suggested a poorly-named environment variable.  For reasons  
you don't care about, "OMPI_MCA_memory_ptmalloc2_disable" would be a  
better name for us (vs. "OMPI_MCA_disable_memory_allocator").  Sorry  
about that!  I just committed the check for  
"OMCA_MCA_memory_ptmalloc2_disable" upstream:

    https://svn.open-mpi.org/trac/ompi/changeset/21479

2. If you want a more general env variable name, like checking for the  
presence of $FAKEROOTKEY (or whatever), let me know and we can also  
add a check for that upstream.  To be clear, I think I'm going to do  
#1 anyway -- it's a nice way for our users to disable this stuff.  But  
I'm not opposed to having a fakeroot-specific environment variable  
check as well.

-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Fri, 19 Jun 2009 20:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Francesco P. Lovergine" <frankie@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Fri, 19 Jun 2009 20:06:03 GMT) Full text and rfc822 format available.

Message #169 received at 531522@bugs.debian.org (full text, mbox):

From: "Francesco P. Lovergine" <frankie@debian.org>
To: 531522@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Still applies
Date: Fri, 19 Jun 2009 22:01:33 +0200
found 531522 1.3.2-2.1
thanks

I have:

dpkg -l|grep openmpi
ii  libopenmpi-dev                                          1.3.2-2.1                      high performance message passing library -- header files
ii  libopenmpi1.3                                           1.3.2-2.1                      high performance message passing library -- shared library
ii  openmpi-common                                          1.3.2-2.1                      high performance message passing library -- common files

But still 

fakeroot mpicc.openmpi -show
/usr/bin/fakeroot: line 178: 13867 Segmentation fault      FAKEROOTKEY=$FAKEROOTKEY LD_LIBRARY_PATH="$PATHS" LD_PRELOAD="$LIB" "$@"

That's on sid/i386 at least, update today.

-- 
Francesco P. Lovergine




Bug marked as found in version 1.3.2-2.1 and reopened. Request was from "Francesco P. Lovergine" <frankie@debian.org> to control@bugs.debian.org. (Fri, 19 Jun 2009 20:06:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sat, 20 Jun 2009 05:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sat, 20 Jun 2009 05:00:03 GMT) Full text and rfc822 format available.

Message #176 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Jeff Squyres <jsquyres@cisco.com>
Cc: Clint Adams <schizo@debian.org>, Manuel Prinz <debian@pinguinkiste.de>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Fri, 19 Jun 2009 23:58:37 -0500
[Message part 1 (text/plain, inline)]
On Fri, Jun 19, 2009 at 06:52:03AM -0400, Jeff Squyres wrote:

> 2. If you want a more general env variable name, like checking for the  
> presence of $FAKEROOTKEY (or whatever), let me know and we can also add a 
> check for that upstream.  To be clear, I think I'm going to do #1 anyway 
> -- it's a nice way for our users to disable this stuff.  But I'm not 
> opposed to having a fakeroot-specific environment variable check as well.

OK, that sounds like a good idea.  Could you add a check for
$FAKEROOTKEY, please.  Just check whether it exists in the
environment.

Thanks,
-Steve
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sat, 20 Jun 2009 11:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sat, 20 Jun 2009 11:30:03 GMT) Full text and rfc822 format available.

Message #181 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: "Steve M. Robbins" <steve@sumost.ca>
Cc: "Clint Adams" <schizo@debian.org>, "Manuel Prinz" <debian@pinguinkiste.de>, <531419@bugs.debian.org>, <531522@bugs.debian.org>, <fakeroot@packages.debian.org>
Subject: Re: mpicc segfaults when called by fakeroot
Date: Sat, 20 Jun 2009 07:23:42 -0400
Done.  The two patches you need are here:

    https://svn.open-mpi.org/trac/ompi/changeset/21479
    https://svn.open-mpi.org/trac/ompi/changeset/21489

I'll push these upstream; they might make it into OMPI v1.3.3.


On Jun 20, 2009, at 12:58 AM, Steve M. Robbins wrote:

> On Fri, Jun 19, 2009 at 06:52:03AM -0400, Jeff Squyres wrote:
>
>> 2. If you want a more general env variable name, like checking for  
>> the
>> presence of $FAKEROOTKEY (or whatever), let me know and we can also  
>> add a
>> check for that upstream.  To be clear, I think I'm going to do #1  
>> anyway
>> -- it's a nice way for our users to disable this stuff.  But I'm not 
>> opposed to having a fakeroot-specific environment variable check as  
>> well.
>
> OK, that sounds like a good idea.  Could you add a check for
> $FAKEROOTKEY, please.  Just check whether it exists in the
> environment.
>
> Thanks,
> -Steve


-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sun, 21 Jun 2009 03:24:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sun, 21 Jun 2009 03:24:02 GMT) Full text and rfc822 format available.

Message #186 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: "Francesco P. Lovergine" <frankie@debian.org>, 531522@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#531522: Still applies
Date: Sat, 20 Jun 2009 22:23:07 -0500
[Message part 1 (text/plain, inline)]
On Fri, Jun 19, 2009 at 10:01:33PM +0200, Francesco P. Lovergine wrote:
> found 531522 1.3.2-2.1
> thanks
> 
> I have:
> 
> dpkg -l|grep openmpi
> ii  libopenmpi-dev                                          1.3.2-2.1                      high performance message passing library -- header files
> ii  libopenmpi1.3                                           1.3.2-2.1                      high performance message passing library -- shared library
> ii  openmpi-common                                          1.3.2-2.1                      high performance message passing library -- common files
> 
> But still 
> 
> fakeroot mpicc.openmpi -show
> /usr/bin/fakeroot: line 178: 13867 Segmentation fault      FAKEROOTKEY=$FAKEROOTKEY LD_LIBRARY_PATH="$PATHS" LD_PRELOAD="$LIB" "$@"
> 
> That's on sid/i386 at least, update today.

Yes.

The fix uploaded requires you to set an environment variable to
avoid the segfault.  

After uploading, the fakeroot maintainer and OpenMPI upstream proposed
a better fix -- one that doesn't require you to set a magic variable.
I plan to do another upload of OpenMPI with the upstream fix instead
of mine.  Then it will be truly fixed.  Until then, you'll need the
magic environment variable.

Regards,
-Steve

[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Sun, 21 Jun 2009 19:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Sun, 21 Jun 2009 19:27:03 GMT) Full text and rfc822 format available.

Message #191 received at 531522@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: 531522@bugs.debian.org
Subject: NMU version 1.3.2-2.2
Date: Sun, 21 Jun 2009 14:23:24 -0500
[Message part 1 (text/plain, inline)]
Hi Maintainers,

I removed my hack in favour of the upstream fix [1].  See attached
diff for revision -2.2.

[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=531522#181

Cheers,
-Steve


[diff (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Mon, 22 Jun 2009 17:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jeff Squyres <jsquyres@cisco.com>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Mon, 22 Jun 2009 17:39:03 GMT) Full text and rfc822 format available.

Message #196 received at 531522@bugs.debian.org (full text, mbox):

From: Jeff Squyres <jsquyres@cisco.com>
To: "Steve M. Robbins" <steve@sumost.ca>, Clint Adams <schizo@debian.org>, Manuel Prinz <debian@pinguinkiste.de>, 531419@bugs.debian.org, 531522@bugs.debian.org, fakeroot@packages.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Mon, 22 Jun 2009 13:38:21 -0400
These patches were accepted into OMPI v1.3.3:

    https://svn.open-mpi.org/trac/ompi/changeset/21493

Exact release date is unknown, but hopefully "soon".



On Jun 20, 2009, at 7:23 AM, Jeff Squyres wrote:

> Done.  The two patches you need are here:
>
>    https://svn.open-mpi.org/trac/ompi/changeset/21479
>    https://svn.open-mpi.org/trac/ompi/changeset/21489
>
> I'll push these upstream; they might make it into OMPI v1.3.3.
>
>
> On Jun 20, 2009, at 12:58 AM, Steve M. Robbins wrote:
>
>> On Fri, Jun 19, 2009 at 06:52:03AM -0400, Jeff Squyres wrote:
>>
>>> 2. If you want a more general env variable name, like checking for  
>>> the
>>> presence of $FAKEROOTKEY (or whatever), let me know and we can  
>>> also add a
>>> check for that upstream.  To be clear, I think I'm going to do #1  
>>> anyway
>>> -- it's a nice way for our users to disable this stuff.  But I'm  
>>> notopposed to having a fakeroot-specific environment variable  
>>> check as well.
>>
>> OK, that sounds like a good idea.  Could you add a check for
>> $FAKEROOTKEY, please.  Just check whether it exists in the
>> environment.
>>
>> Thanks,
>> -Steve
>
>
> -- 
> Jeff Squyres
> Cisco Systems
>


-- 
Jeff Squyres
Cisco Systems





Information forwarded to debian-bugs-dist@lists.debian.org, Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>:
Bug#531522; Package libopenmpi-dev. (Tue, 23 Jun 2009 22:07:53 GMT) Full text and rfc822 format available.

Acknowledgement sent to Manuel Prinz <debian@pinguinkiste.de>:
Extra info received and forwarded to list. Copy sent to Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>. (Tue, 23 Jun 2009 22:08:47 GMT) Full text and rfc822 format available.

Message #201 received at 531522@bugs.debian.org (full text, mbox):

From: Manuel Prinz <debian@pinguinkiste.de>
To: Jeff Squyres <jsquyres@cisco.com>
Cc: "Steve M. Robbins" <steve@sumost.ca>, Clint Adams <schizo@debian.org>, 531419@bugs.debian.org, 531522@bugs.debian.org
Subject: Re: mpicc segfaults when called by fakeroot
Date: Wed, 24 Jun 2009 00:02:12 +0200
Hi Jeff! Hi Steve!

Thanks for implementing a solution and pushing it upstream!

The last NMU by Steve did not make it into Debian. I'm preparing an
upload at the moment, acknowleding the NMUs and fixing all RC bugs. I'll
upload later tonight or tomorrow.

Thanks again for working on the issue while I was away! It's very
appreciated!

Best regards
Manuel





Reply sent to Manuel Prinz <manuel@debian.org>:
You have taken responsibility. (Tue, 23 Jun 2009 23:27:04 GMT) Full text and rfc822 format available.

Notification sent to Kurt Roeckx <kurt@roeckx.be>:
Bug acknowledged by developer. (Tue, 23 Jun 2009 23:27:04 GMT) Full text and rfc822 format available.

Message #206 received at 531522-close@bugs.debian.org (full text, mbox):

From: Manuel Prinz <manuel@debian.org>
To: 531522-close@bugs.debian.org
Subject: Bug#531522: fixed in openmpi 1.3.2-3
Date: Tue, 23 Jun 2009 23:17:34 +0000
Source: openmpi
Source-Version: 1.3.2-3

We believe that the bug you reported is fixed in the latest version of
openmpi, which is due to be installed in the Debian FTP archive:

libopenmpi-dbg_1.3.2-3_amd64.deb
  to pool/main/o/openmpi/libopenmpi-dbg_1.3.2-3_amd64.deb
libopenmpi-dev_1.3.2-3_amd64.deb
  to pool/main/o/openmpi/libopenmpi-dev_1.3.2-3_amd64.deb
libopenmpi1.3_1.3.2-3_amd64.deb
  to pool/main/o/openmpi/libopenmpi1.3_1.3.2-3_amd64.deb
openmpi-bin_1.3.2-3_amd64.deb
  to pool/main/o/openmpi/openmpi-bin_1.3.2-3_amd64.deb
openmpi-common_1.3.2-3_all.deb
  to pool/main/o/openmpi/openmpi-common_1.3.2-3_all.deb
openmpi-doc_1.3.2-3_all.deb
  to pool/main/o/openmpi/openmpi-doc_1.3.2-3_all.deb
openmpi_1.3.2-3.diff.gz
  to pool/main/o/openmpi/openmpi_1.3.2-3.diff.gz
openmpi_1.3.2-3.dsc
  to pool/main/o/openmpi/openmpi_1.3.2-3.dsc



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 531522@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Manuel Prinz <manuel@debian.org> (supplier of updated openmpi package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 24 Jun 2009 00:33:23 +0200
Source: openmpi
Binary: openmpi-bin libopenmpi-dev libopenmpi1.3 openmpi-common openmpi-doc libopenmpi-dbg
Architecture: source amd64 all
Version: 1.3.2-3
Distribution: unstable
Urgency: low
Maintainer: Debian OpenMPI Maintainers <pkg-openmpi-maintainers@lists.alioth.debian.org>
Changed-By: Manuel Prinz <manuel@debian.org>
Description: 
 libopenmpi-dbg - high performance message passing library -- debug library
 libopenmpi-dev - high performance message passing library -- header files
 libopenmpi1.3 - high performance message passing library -- shared library
 openmpi-bin - high performance message passing library -- binaries
 openmpi-common - high performance message passing library -- common files
 openmpi-doc - high performance message passing library -- man pages
Closes: 531184 531522 532008 532910
Changes: 
 openmpi (1.3.2-3) unstable; urgency=low
 .
   * Re-uploading, as last upload was not successful.
   * Acknowledgement of NMU. Thanks to Steve M. Robbins for the patches and
     NMUs! Closes: #531522.
   * Removing ancient mpicc, mpiCC and mpiexec master alternatives in preinst.
     Closes: #531184, #532008, #532910.
   * debian/control: Bumped Standards-Version. No changes needed.
   * Fixed typo in README.Debian of openmpi-bin.
Checksums-Sha1: 
 2ec16de9b730b42bfb2df47a404458db2ce0f400 1544 openmpi_1.3.2-3.dsc
 4eac4433ce12e37744ebd7cae6a8f9a1d72dfb43 21521 openmpi_1.3.2-3.diff.gz
 b7c5b7626ce51238d319bf2582ac962f337467ad 136734 openmpi-bin_1.3.2-3_amd64.deb
 1dbb6ecf3cfd7da7b5e29542e8eb99e1c529977c 2564720 libopenmpi-dev_1.3.2-3_amd64.deb
 2867b62e6f51e1628b9dfa7125daa30c8aa2bc9b 1253426 libopenmpi1.3_1.3.2-3_amd64.deb
 f72411bd3f1cef3e116cbfec71e660ff254953c5 5310924 libopenmpi-dbg_1.3.2-3_amd64.deb
 3dfbf8fafd44f1164c513be6676675844cec5d7c 78216 openmpi-common_1.3.2-3_all.deb
 a379e2bc3626ceeacb99bed15f950541a0cd7319 462288 openmpi-doc_1.3.2-3_all.deb
Checksums-Sha256: 
 52de72a4ae5b9e74007e922246290782d69495cd8bb1b734bcd7eb23353b2473 1544 openmpi_1.3.2-3.dsc
 323e240f2d5bb282b82aa0a493dafb19c6f3d5d8f51134c327473df2db086dab 21521 openmpi_1.3.2-3.diff.gz
 6402cb5128b8ff4b4298d7440428e726271f9e3edbf4ed5428dce8702aff7417 136734 openmpi-bin_1.3.2-3_amd64.deb
 1ab1176ab78e65c8189f26a2b728b46642f3b225e24a88193f31043d84edb8d4 2564720 libopenmpi-dev_1.3.2-3_amd64.deb
 54bbcd4b38665776ea7d6836ca6d533d8ff146a0617b6621c36376555a4052ec 1253426 libopenmpi1.3_1.3.2-3_amd64.deb
 5a2e667e4d73415ced0d43fac25c0b5c4ec2122e780b23a5ed6e1ca3878b0bcb 5310924 libopenmpi-dbg_1.3.2-3_amd64.deb
 7f2cc86a8dcd21aef328f20f5a1060d4e5371e8a17e218487b985c0da0a87dd7 78216 openmpi-common_1.3.2-3_all.deb
 2cab58646374673b5d66ed97de1fd8ee76bd79043116be19a5388705e0e92e21 462288 openmpi-doc_1.3.2-3_all.deb
Files: 
 876d3dc81e371d3e14e4f609054a8382 1544 net extra openmpi_1.3.2-3.dsc
 784d2feca029e90900d9d1d8558302d3 21521 net extra openmpi_1.3.2-3.diff.gz
 d114862474d0b47804b16ecaa0aac5d8 136734 net extra openmpi-bin_1.3.2-3_amd64.deb
 399bb2aebab984ddc883b232a5f6136c 2564720 libdevel extra libopenmpi-dev_1.3.2-3_amd64.deb
 dc5d4a6329dbb70e59b02e7f8cb608be 1253426 libs extra libopenmpi1.3_1.3.2-3_amd64.deb
 725cb9f760cc6c3c12354892e2a37ddb 5310924 debug extra libopenmpi-dbg_1.3.2-3_amd64.deb
 149521a82d1a619e19e180f15adc0cba 78216 net extra openmpi-common_1.3.2-3_all.deb
 713317142c5364ea072c7bcef8de34b3 462288 doc extra openmpi-doc_1.3.2-3_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkpBYOwACgkQ8WlhyMyNeVdCyQCglcI38iWia1crKtEG0OHtZJOQ
CtQAnRzFHWXFu2gks5IfoEhimcClTrsm
=BXy9
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 24 Jul 2009 07:30:44 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 03:31:05 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.